f61222ce3d7e4b8dd95951fb7a3b517adaf4cddc
[xfstests-dev.git] / tests / generic / 043
1 #! /bin/bash
2 # FSQA Test No. 043
3 #
4 # Test for NULL files problem
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1    # failure is the default!
32 trap "exit \$status" 0 1 2 3 15
33
34 # get standard environment, filters and checks
35 . ./common/rc
36 . ./common/filter
37
38 # real QA test starts here
39 _supported_fs generic
40 _supported_os Linux
41
42 _require_scratch
43 _require_scratch_shutdown
44 _require_xfs_io_command "fiemap"
45 _scratch_mkfs >/dev/null 2>&1
46 _require_metadata_journaling $SCRATCH_DEV
47 _scratch_mount
48
49 # create files
50 i=1;
51 while [ $i -lt 1000 ]
52 do
53         file=$SCRATCH_MNT/$i
54         $XFS_IO_PROG -f -c "pwrite -b 64k -S 0xff 0 64k" $file > /dev/null
55         if [ $? -ne 0 ]
56         then
57                 echo error creating/writing file $file
58                 exit
59         fi
60         let i=$i+1
61 done
62
63 # give the system a chance to write something out
64 sleep 10
65
66 _scratch_shutdown
67
68 _scratch_unmount
69 _scratch_mount
70 _scratch_unmount
71 if [ ! _check_scratch_fs ]
72 then
73         echo error detected in filesystem
74         exit
75 fi
76 _scratch_mount
77
78 # check file size and contents
79 i=1;
80 while [ $i -lt 1000 ]
81 do
82         file=$SCRATCH_MNT/$i
83         # if file does not exist, the create was not logged, skip it
84         if [ -e $file ]
85         then
86                 # if file size is zero it cannot be corrupt, skip it
87                 if [ -s $file ]
88                 then
89                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
90                         num_extents=`_count_extents $file`
91                         num_holes=`_count_holes $file`
92                         if [ $num_extents -eq 0 ]; then
93                                 echo corrupt file $file - non-zero size but no extents
94                         elif [ $num_holes -ne 0 ]; then
95                                 echo corrupt file $file - contains holes
96                         else
97                                 rm -f $file
98                         fi
99                 else
100                         rm -f $file
101                 fi
102         fi
103         let i=$i+1
104 done
105
106 status=0
107 exit